using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Drawing;

namespace DOOM {
    public partial class DOOM {

        public Device RenderDevice = null;

        public bool InitialiseDevice() {
            try {
                
                PresentParameters Params = new PresentParameters();
                
                Params.Windowed = true;

                Params.SwapEffect = SwapEffect.Discard;
                Params.EnableAutoDepthStencil = true;
                Params.AutoDepthStencilFormat = DepthFormat.D24X8;
                Params.MultiSample = MultiSampleType.FourSamples;

                
                RenderDevice = new Device(0, DeviceType.Hardware, this, CreateFlags.MixedVertexProcessing,  Params);
                RenderDevice.DeviceReset += new EventHandler(RenderDevice_DeviceReset);

                RenderDevice_DeviceReset(null, null);
                //SpriteRenderer = new Sprite(RenderDevice);


                return true;

            } catch (DirectXException dex) {
                Console.WriteLine(dex);
                return false;
            }
        }

        void RenderDevice_DeviceReset(object sender, EventArgs e) {
            // Reset...
            
            if (RenderDevice == null) return;

            RenderDevice.RenderState.CullMode = Cull.CounterClockwise;
            RenderDevice.RenderState.Lighting = false;
            RenderDevice.RenderState.ZBufferEnable = false;

            RenderDevice.RenderState.FogColor = Color.Black;
            RenderDevice.RenderState.FogTableMode = FogMode.Exp;
            RenderDevice.RenderState.FogDensity = 0.00025f;
            RenderDevice.RenderState.FogEnable = true;

            RenderDevice.SamplerState[0].MinFilter = TextureFilter.PyramidalQuad;
            RenderDevice.SamplerState[0].MipFilter = TextureFilter.PyramidalQuad;

            RenderDevice.RenderState.SourceBlend = Blend.SourceAlpha;
            RenderDevice.RenderState.DestinationBlend = Blend.InvSourceAlpha;
            RenderDevice.RenderState.AlphaBlendEnable = true;

            RenderDevice.RenderState.ZBufferEnable = true;

            RenderDevice.RenderState.Clipping = true;

            
        }
    }
}