using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using DOOM.WAD;
using DOOM.Levels;
using Microsoft.DirectX.Direct3D;

namespace DOOM {
    public partial class DOOM : Form {

        public Wad WadFile = null;
        public Level CurrentLevel;

        public DOOM() {
            InitializeComponent();
        }

        private float MoveSpeed = 0.0f;
        private float LookSpeed = 0.0f;
        private float HeightSpeed = 0.0f;

        private void DOOM_KeyDown(object sender, KeyEventArgs e) {
            switch (e.KeyCode) {
                case Keys.Up:
                    MoveSpeed = 0.7f;
                    break;
                case Keys.Down:
                    MoveSpeed = -0.7f;
                    break;
                case Keys.Left:
                    LookSpeed = -2.0f;
                    break;
                case Keys.Right:
                    LookSpeed = 2.0f;
                    break;
                case Keys.A:
                    HeightSpeed = 0.6f;
                    break;
                case Keys.Z:
                    HeightSpeed = -0.6f;
                    break;
                case Keys.Escape:
                    this.Close();
                    break;
            }

        }

        private void DOOM_KeyUp(object sender, KeyEventArgs e) {
            switch (e.KeyCode) {
                case Keys.Up:
                case Keys.Down:
                    MoveSpeed = 0.0f;
                    break;
                case Keys.Left:
                case Keys.Right:
                    LookSpeed = 0.0f;
                    break;
                case Keys.A:
                case Keys.Z:
                    HeightSpeed = 0.0f;
                    break;
            }
        }

        private void DOOM_FormClosing(object sender, FormClosingEventArgs e) {
            Console.WriteLine("Cleaning up.");
            CleanUpUpdateEnvironment();
            foreach (TextureAnimation T in SolidWalls) {
                T.Geometry.Dispose();
                foreach (Texture Tex in T.TextureList) Tex.Dispose();
            }
            foreach (TextureAnimation T in TransparentWalls) {
                T.Geometry.Dispose();
                foreach (Texture Tex in T.TextureList) Tex.Dispose();
            }
            foreach (TextureAnimation T in Floors) {
                T.Geometry.Dispose();
                foreach (Texture Tex in T.TextureList) Tex.Dispose();
            }
        }

    }
}