// Flat decoding
using System;
using System.Drawing;
using System.Drawing.Imaging;

namespace DOOM.WAD {
    public partial class Wad {
        public static Bitmap DecodeFlat(Lump FlatFile) {
            Bitmap Return = new Bitmap(64, 64, System.Drawing.Imaging.PixelFormat.Format32bppRgb);
            if (FlatFile.Size == 4096) {
                BitmapData Locked = Return.LockBits(new Rectangle(0, 0, 64, 64), ImageLockMode.WriteOnly, PixelFormat.Format32bppRgb);
                unsafe {
                    int* p = (int*)Locked.Scan0.ToPointer();
                    for (int i = 0; i < 4096; ++i) {
                        *p++ = FlatFile.Parent.Palettes[0].Colours[FlatFile.Data[i]].ToArgb();
                    }
                }
                Return.UnlockBits(Locked);
            }
            return Return;
        }
    }
}