// Palette management class
using System;
using System.Drawing;

namespace DOOM.WAD {
    public partial class Wad {
        
        /// <summary>
        /// Represents a single 256-colour palette.
        /// </summary>
        public class Palette {
            public Color[] Colours;
            public Palette() {
                this.Colours = new Color[256];
            }
        }

        /// <summary>
        /// Palette information for the WAD
        /// </summary>
        public Palette[] Palettes;

        private void DecodePalette(Lump PaletteFile) {
            int PaletteCount = PaletteFile.Size / 768;
            Palettes = new Palette[PaletteCount];
            for (int i = 0; i < PaletteCount; ++i) {
                Palettes[i] = new Palette();
                int PaletteFileOffset = i*768;
                for (int j = 0; j < 768; j += 3) {
                    Palettes[i].Colours[j / 3] =
                        Color.FromArgb(
                            Math.Min(0xFF, (int)((float)PaletteFile.Data[PaletteFileOffset + j + 0] * 1.0f)),
                            Math.Min(0xFF, (int)((float)PaletteFile.Data[PaletteFileOffset + j + 1] * 1.0f)),
                            Math.Min(0xFF, (int)((float)PaletteFile.Data[PaletteFileOffset + j + 2] * 1.0f))
                        );
                }
            }
        }

    }
}
