// Patch index decoding
using System;
using System.Drawing;
using System.Collections;

namespace DOOM.WAD {
    public partial class Wad {

        /// <summary>
        /// Links a patch index to a lump index for texture decoding.
        /// </summary>
        private int[] PatchIndices = null;

        /// <summary>
        /// Decodes the patch index (PNAMES) lump 
        /// </summary>
        private void DecodePatchIndices(Lump PatchNames) {

            int PatchCount =
                (PatchNames.Data[0] << 00) +
                (PatchNames.Data[1] << 08) +
                (PatchNames.Data[2] << 16) +
                (PatchNames.Data[3] << 24);

            PatchIndices = new int[PatchCount];

            for (int i = 0; i < PatchCount; ++i) {
                string PatchName = "";
                for (int j = 0; j < 8; ++j) {
                    PatchName += (char)PatchNames.Data[j + i * 8 + 4];                    
                }
                PatchName = FixString(PatchName);
                object GetPatchLumpIndex = PatchNames.Parent.LumpIndex[PatchName];
                if (GetPatchLumpIndex == null) {
                    Console.WriteLine("Patch " + PatchName + " not found.");
                    PatchIndices[i] = 0;
                } else {
                    PatchIndices[i] = (int)GetPatchLumpIndex;
                }
            }
        }
    }
}