// SubSector decoding
using System;
using System.Drawing;
using System.Drawing.Imaging;

namespace DOOM.WAD {
    public partial class Wad {

        public static SubSector[] DecodeSubSectors(Lump SubSectorFile) {
            SubSector[] Return = new SubSector[SubSectorFile.Size / 4];
            for (int i = 0; i < SubSectorFile.Size; i += 4) {
                Return[i / 4] = new SubSector(
                    i / 4,
                    SubSectorFile.Data[i + 0] + (SubSectorFile.Data[i + 1] << 8),
                    SubSectorFile.Data[i + 2] + (SubSectorFile.Data[i + 3] << 8)
                );
            }
            return Return;
        }
        public class SubSector {

            /// <summary>
            /// Identifier
            /// </summary>
            public readonly int ID;

            /// <summary>
            /// The number of segments in this subsector
            /// </summary>
            public readonly int SegCount;
            
            /// <summary>
            /// The index of the first segment
            /// </summary>
            public readonly int SegIndex;

            public SubSector(int ID, int SegCount, int SegIndex) {
                this.ID = ID;
                this.SegCount = SegCount;
                this.SegIndex = SegIndex;
            }
            
        }
    }
}